/**
 * Interface for the value in ClassLoopNext
 *
 * @export
 * @interface ClassLoopValue
 */
export interface ClassLoopValue {
    key?: string;
    value: any;
}
/**
 * Interface for the next() function in Iterator
 *
 * @export
 * @interface ClassLoopNext
 */
export interface ClassLoopNext {
    value: ClassLoopValue;
    done: boolean;
}
/**
 * Interface for the Iterator Function
 *
 * @export
 * @interface LoopForIterator
 */
export interface LoopForIterator {
    next: () => ClassLoopNext;
}
/**
 * ClassLoop main class
 *
 * @export
 * @class ClassLoop
 */
export declare abstract class ClassLoop {
    [key: string]: any;
    [Symbol.iterator](): LoopForIterator;
    protected loopForIterator(): LoopForIterator;
}
