"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * ClassLoop main class
 *
 * @export
 * @class ClassLoop
 */
class ClassLoop {
    [Symbol.iterator]() {
        return this.loopForIterator();
    }
    loopForIterator() {
        const keys = Object.keys(this);
        let counter = keys.length;
        return {
            next: () => {
                const currentKey = keys.shift();
                counter--;
                return {
                    value: {
                        key: currentKey,
                        value: currentKey !== undefined ? this[currentKey] : undefined
                    },
                    done: counter <= -1
                };
            }
        };
    }
}
exports.ClassLoop = ClassLoop;
//# sourceMappingURL=class_loop.js.map